`timescale 1ns/1ps

module counter 
#(
	parameter COUNT_TO = 24
)
(
    input 							  clk_i		,
    input 							  reset_ni	,
    input 							  count_en_i,
    output reg [clogb2(COUNT_TO):0]   count_o
);

`include "clog_function.vh"

always @(posedge clk_i or negedge reset_ni) begin
    if(~reset_ni)
        count_o <= 'b0;
    else
        if(count_o == COUNT_TO)
            count_o <= count_o;
        else
            if(count_en_i)
                count_o <= count_o + 1;
end

endmodule