module function_fTB();

`include "clog_function.vh"

parameter DATA_WIDTH = 32;
parameter COUNT_TO	 = 16;
parameter ADDR_WIDTH = 32;

reg 						    clk_i		   ;
reg 						    reset_ni	   ;
reg      [DATA_WIDTH-1:0] 	    R0_i		   ;
reg      [DATA_WIDTH-1:0] 	    R1_i		   ;
reg      [clogb2(COUNT_TO)-1:0] round_number_i ;
reg      [DATA_WIDTH-1:0] 	    K_key_odd	   ;
reg      [DATA_WIDTH-1:0] 	    K_key_even	   ;

wire     [DATA_WIDTH-1:0]  	  F0_o		    ;
wire     [DATA_WIDTH-1:0]  	  F1_o		    ;
wire     [ADDR_WIDTH-1:0]  	  K_addr_odd_o  ;
wire     [ADDR_WIDTH-1:0]  	  K_addr_even_o ;

function_f
#(
	.DATA_WIDTH(DATA_WIDTH),
	.COUNT_TO  (COUNT_TO  ),
	.ADDR_WIDTH(ADDR_WIDTH)
)
function_fDUT
(
	.clk_i		   (clk_i		    ), 
    .reset_ni	   (reset_ni	    ), 
    .R0_i		   (R0_i		    ), 
    .R1_i		   (R1_i		    ), 
    .round_number_i(round_number_i	),
    .K_key_odd	   (K_key_odd	    ), 
    .K_key_even	   (K_key_even		),
                  
    .F0_o		   (F0_o		    ), 
    .F1_o		   (F1_o		    ), 
    .K_addr_odd_o  (K_addr_odd_o  	),
    .K_addr_even_o (K_addr_even_o	)
);

always begin
	#15 clk_i <= ~clk_i;
end

initial begin
	clk_i = 'b0;
	reset_ni = 'b1;
	R0_i ='bx;
	R1_i ='bx;
	
	@(posedge clk_i)
	reset_ni ='b0;
	@(posedge clk_i)
	reset_ni = 'b1;
	K_key_odd = 'h0;
	K_key_even = 'h0;
	R0_i ='h1111;
	R1_i ='h5555;
	@(posedge clk_i)
	R0_i = 'h5678;
	R1_i = 'h1234;
end

endmodule