module function_hTB();

parameter DATA_WIDTH = 32;

reg 				  clk_i			 ;	   
reg 				  reset_ni       ;
reg [DATA_WIDTH-1:0]  data_i         ;
reg [DATA_WIDTH-1:0]  key_schedule0_i;
reg [DATA_WIDTH-1:0]  key_schedule1_i;

wire [DATA_WIDTH-1:0] data_o		 ;

function_h
#(
	.DATA_WIDTH(DATA_WIDTH)
)
function_hDUT
(
	.clk_i			(clk_i			),			 
	.reset_ni       (reset_ni       ),
	.data_i         (data_i         ),
	.key_schedule0_i(key_schedule0_i),
	.key_schedule1_i(key_schedule1_i),
	                
	.data_o		    (data_o		 	)
);

always begin
	#15 clk_i <= ~clk_i;
end

initial begin
	clk_i = 'b0;
	reset_ni = 'b1;
	data_i	 ='bx;    
    key_schedule0_i = 'h0;
    key_schedule1_i = 'h0;
	@(posedge clk_i)
	reset_ni = 'b0;
	@(posedge clk_i)
	reset_ni = 'b1;
	data_i = 'h12345678;
end

endmodule