`timescale 1ns/1ps

module h_comapctTB();

parameter DATA_WIDTH = 32;

reg [DATA_WIDTH-1:0] data_i         ;
reg [DATA_WIDTH-1:0] key_schedule0_i;
reg [DATA_WIDTH-1:0] key_schedule1_i;

wire [DATA_WIDTH-1:0] data_o;

h_compact
#(
	.DATA_WIDTH(DATA_WIDTH)
)
h_compactDUT
(
	.data_i         (data_i         ),
	.key_schedule0_i(key_schedule0_i),
	.key_schedule1_i(key_schedule1_i),
	
	.data_o         (data_o         )
); 

initial begin
	key_schedule0_i = {32{1'b1}};
	key_schedule1_i	= {32{1'b1}};
	data_i = 'd0;
	#15 data_i = 'd1;
	#15 data_i = 'd2;
	#15 data_i = 'd3;
	#15 data_i = 'd4;
end
endmodule