module q_permutationTB();
parameter DATA_WIDTH = 8;
parameter Q_NR = 0;

reg clk_i;
reg reset_ni;
reg [DATA_WIDTH-1:0] q_i;
wire [DATA_WIDTH-1:0] q_o;


q_permutation 
#(
    .DATA_WIDTH(8),    
    .Q_NR(0)
)
inst
(
    .clk_i(clk_i),
    .reset_ni(reset_ni),
    .q_i(q_i),
    .q_o(q_o)
);

always begin
    #5 clk_i <= ~clk_i;
end

initial begin
clk_i = 'b0;
reset_ni = 'b1;
q_i = 'bx;
@(posedge clk_i)
reset_ni = 'b0;
q_i = 'd1;
repeat (2) @(posedge clk_i)
reset_ni = 'b1;
@(posedge clk_i)
q_i = 'd2;
@(posedge clk_i)
q_i = 'd3;
@(posedge clk_i)
q_i = 'd4;
@(posedge clk_i)
q_i = 'd5;
end
endmodule