module s_box_combinedTB();

parameter DATA_WIDTH = 32;
parameter Q_LEFT 	 = 0 ;
parameter Q_MIDDLE   = 0 ; 
parameter Q_RIGHT    = 0 ;

reg 				      clk_i		     ;
reg 				      reset_ni	     ;
reg [DATA_WIDTH-1:0]      data_i	     ;
reg [DATA_WIDTH-1:0]      key_schedule0_i;
reg [DATA_WIDTH-1:0]      key_schedule1_i;

wire [(DATA_WIDTH/4)-1:0] box0_o		 ;
wire [(DATA_WIDTH/4)-1:0] box1_o		 ;
wire [(DATA_WIDTH/4)-1:0] box2_o		 ;
wire [(DATA_WIDTH/4)-1:0] box3_o		 ;

s_box_combined
#(
	.DATA_WIDTH(DATA_WIDTH),
	.Q_LEFT    (Q_LEFT 	  ),
	.Q_MIDDLE  (Q_MIDDLE  ),
	.Q_RIGHT   (Q_RIGHT   )
)
s_box_combinedDUT
(
	.clk_i		     (clk_i		     ),
	.reset_ni	     (reset_ni	     ),
	.data_i	         (data_i	     ),
	.key_schedule0_i (key_schedule0_i),
	.key_schedule1_i (key_schedule1_i),
	.box0_o		     (box0_o		 ),
	.box1_o		     (box1_o		 ),
	.box2_o		     (box2_o		 ),
	.box3_o	         (box3_o		 )
); 

always begin
	#15 clk_i <= ~clk_i;
end

initial begin
	clk_i = 'b0;
	reset_ni = 'b1;
	data_i	 ='bx;    
    key_schedule0_i = 'h0;
    key_schedule1_i = 'h0;
	@(posedge clk_i)
	reset_ni = 'b0;
	@(posedge clk_i)
	reset_ni = 'b1;
	data_i = 'h12345678;
end

endmodule